# coding: utf-8

"""
    FireHydrant API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from firehydrant_api_client.models.author_entity import AuthorEntity
from firehydrant_api_client.models.external_resource_entity import ExternalResourceEntity
from firehydrant_api_client.models.links_entity import LinksEntity
from typing import Optional, Set
from typing_extensions import Self

class FunctionalityEntity(BaseModel):
    """
    FunctionalityEntity model
    """ # noqa: E501
    id: Optional[StrictStr] = None
    name: Optional[StrictStr] = None
    slug: Optional[StrictStr] = None
    description: Optional[StrictStr] = None
    created_at: Optional[datetime] = None
    updated_at: Optional[datetime] = None
    labels: Optional[Dict[str, Any]] = Field(default=None, description="An object of label key and values")
    active_incidents: Optional[List[StrictStr]] = Field(default=None, description="List of active incident guids")
    links: Optional[List[LinksEntity]] = Field(default=None, description="List of links attached to this functionality.")
    owner: Optional[TeamEntity] = None
    alert_on_add: Optional[StrictBool] = None
    auto_add_responding_team: Optional[StrictBool] = None
    updated_by: Optional[AuthorEntity] = None
    services: Optional[List[ServiceEntity]] = Field(default=None, description="Services this functionality provides")
    external_resources: Optional[List[ExternalResourceEntity]] = Field(default=None, description="Information about known linkages to representations of services outside of FireHydrant.")
    teams: Optional[List[TeamEntity]] = Field(default=None, description="List of teams attached to the functionality")
    __properties: ClassVar[List[str]] = ["id", "name", "slug", "description", "created_at", "updated_at", "labels", "active_incidents", "links", "owner", "alert_on_add", "auto_add_responding_team", "updated_by", "services", "external_resources", "teams"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FunctionalityEntity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in links (list)
        _items = []
        if self.links:
            for _item_links in self.links:
                if _item_links:
                    _items.append(_item_links.to_dict())
            _dict['links'] = _items
        # override the default output from pydantic by calling `to_dict()` of owner
        if self.owner:
            _dict['owner'] = self.owner.to_dict()
        # override the default output from pydantic by calling `to_dict()` of updated_by
        if self.updated_by:
            _dict['updated_by'] = self.updated_by.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in services (list)
        _items = []
        if self.services:
            for _item_services in self.services:
                if _item_services:
                    _items.append(_item_services.to_dict())
            _dict['services'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in external_resources (list)
        _items = []
        if self.external_resources:
            for _item_external_resources in self.external_resources:
                if _item_external_resources:
                    _items.append(_item_external_resources.to_dict())
            _dict['external_resources'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in teams (list)
        _items = []
        if self.teams:
            for _item_teams in self.teams:
                if _item_teams:
                    _items.append(_item_teams.to_dict())
            _dict['teams'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FunctionalityEntity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "slug": obj.get("slug"),
            "description": obj.get("description"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "labels": obj.get("labels"),
            "active_incidents": obj.get("active_incidents"),
            "links": [LinksEntity.from_dict(_item) for _item in obj["links"]] if obj.get("links") is not None else None,
            "owner": TeamEntity.from_dict(obj["owner"]) if obj.get("owner") is not None else None,
            "alert_on_add": obj.get("alert_on_add"),
            "auto_add_responding_team": obj.get("auto_add_responding_team"),
            "updated_by": AuthorEntity.from_dict(obj["updated_by"]) if obj.get("updated_by") is not None else None,
            "services": [ServiceEntity.from_dict(_item) for _item in obj["services"]] if obj.get("services") is not None else None,
            "external_resources": [ExternalResourceEntity.from_dict(_item) for _item in obj["external_resources"]] if obj.get("external_resources") is not None else None,
            "teams": [TeamEntity.from_dict(_item) for _item in obj["teams"]] if obj.get("teams") is not None else None
        })
        return _obj

from firehydrant_api_client.models.service_entity import ServiceEntity
from firehydrant_api_client.models.team_entity import TeamEntity
# TODO: Rewrite to not use raise_errors
FunctionalityEntity.model_rebuild(raise_errors=False)

