# coding: utf-8

"""
    FireHydrant API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from firehydrant_api_client.models.imports_import_error_entity import ImportsImportErrorEntity
from typing import Optional, Set
from typing_extensions import Self

class ImportsImportableResourceEntity(BaseModel):
    """
    ImportsImportableResourceEntity
    """ # noqa: E501
    import_errors: Optional[List[ImportsImportErrorEntity]] = None
    imported_at: Optional[datetime] = None
    remote_id: Optional[StrictStr] = None
    state: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["import_errors", "imported_at", "remote_id", "state"]

    @field_validator('state')
    def state_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['selected', 'skipped', 'imported', 'errored']):
            raise ValueError("must be one of enum values ('selected', 'skipped', 'imported', 'errored')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ImportsImportableResourceEntity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in import_errors (list)
        _items = []
        if self.import_errors:
            for _item_import_errors in self.import_errors:
                if _item_import_errors:
                    _items.append(_item_import_errors.to_dict())
            _dict['import_errors'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ImportsImportableResourceEntity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "import_errors": [ImportsImportErrorEntity.from_dict(_item) for _item in obj["import_errors"]] if obj.get("import_errors") is not None else None,
            "imported_at": obj.get("imported_at"),
            "remote_id": obj.get("remote_id"),
            "state": obj.get("state")
        })
        return _obj


