# coding: utf-8

"""
    FireHydrant API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from firehydrant_api_client.models.author_entity import AuthorEntity
from firehydrant_api_client.models.change_event_entity import ChangeEventEntity
from typing import Optional, Set
from typing_extensions import Self

class IncidentsRelatedChangeEventEntity(BaseModel):
    """
    Incidents_RelatedChangeEventEntity model
    """ # noqa: E501
    id: Optional[StrictStr] = None
    created_at: Optional[datetime] = None
    updated_at: Optional[datetime] = None
    why: Optional[StrictStr] = Field(default=None, description="The reason why this change event is related to this incident")
    type: Optional[StrictStr] = None
    change_event: Optional[ChangeEventEntity] = None
    incident_id: Optional[StrictStr] = None
    created_by: Optional[AuthorEntity] = None
    __properties: ClassVar[List[str]] = ["id", "created_at", "updated_at", "why", "type", "change_event", "incident_id", "created_by"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['caused', 'fixed', 'suspect', 'dismissed']):
            raise ValueError("must be one of enum values ('caused', 'fixed', 'suspect', 'dismissed')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IncidentsRelatedChangeEventEntity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of change_event
        if self.change_event:
            _dict['change_event'] = self.change_event.to_dict()
        # override the default output from pydantic by calling `to_dict()` of created_by
        if self.created_by:
            _dict['created_by'] = self.created_by.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IncidentsRelatedChangeEventEntity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "why": obj.get("why"),
            "type": obj.get("type"),
            "change_event": ChangeEventEntity.from_dict(obj["change_event"]) if obj.get("change_event") is not None else None,
            "incident_id": obj.get("incident_id"),
            "created_by": AuthorEntity.from_dict(obj["created_by"]) if obj.get("created_by") is not None else None
        })
        return _obj


