# coding: utf-8

"""
    FireHydrant API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from firehydrant_api_client.models.post_v1_checklist_templates_checks_inner import PostV1ChecklistTemplatesChecksInner
from firehydrant_api_client.models.post_v1_services_teams_inner import PostV1ServicesTeamsInner
from typing import Optional, Set
from typing_extensions import Self

class PostV1ChecklistTemplates(BaseModel):
    """
    Creates a checklist template for the organization
    """ # noqa: E501
    name: StrictStr
    checks: List[PostV1ChecklistTemplatesChecksInner] = Field(description="An array of checks for the checklist template")
    description: Optional[StrictStr] = None
    team_id: Optional[StrictStr] = Field(default=None, description="The ID of the Team that owns the checklist template")
    connected_services: Optional[List[PostV1ServicesTeamsInner]] = Field(default=None, description="Array of service IDs to attach checklist template to")
    __properties: ClassVar[List[str]] = ["name", "checks", "description", "team_id", "connected_services"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PostV1ChecklistTemplates from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in checks (list)
        _items = []
        if self.checks:
            for _item_checks in self.checks:
                if _item_checks:
                    _items.append(_item_checks.to_dict())
            _dict['checks'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in connected_services (list)
        _items = []
        if self.connected_services:
            for _item_connected_services in self.connected_services:
                if _item_connected_services:
                    _items.append(_item_connected_services.to_dict())
            _dict['connected_services'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PostV1ChecklistTemplates from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "checks": [PostV1ChecklistTemplatesChecksInner.from_dict(_item) for _item in obj["checks"]] if obj.get("checks") is not None else None,
            "description": obj.get("description"),
            "team_id": obj.get("team_id"),
            "connected_services": [PostV1ServicesTeamsInner.from_dict(_item) for _item in obj["connected_services"]] if obj.get("connected_services") is not None else None
        })
        return _obj


