# coding: utf-8

"""
    FireHydrant API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from firehydrant_api_client.models.post_v1_services_external_resources_inner import PostV1ServicesExternalResourcesInner
from firehydrant_api_client.models.post_v1_services_functionalities_inner import PostV1ServicesFunctionalitiesInner
from firehydrant_api_client.models.post_v1_services_links_inner import PostV1ServicesLinksInner
from firehydrant_api_client.models.post_v1_services_owner import PostV1ServicesOwner
from firehydrant_api_client.models.post_v1_services_teams_inner import PostV1ServicesTeamsInner
from typing import Optional, Set
from typing_extensions import Self

class PostV1Services(BaseModel):
    """
    Creates a service for the organization, you may also create or attach functionalities to the service on create.
    """ # noqa: E501
    name: StrictStr
    description: Optional[StrictStr] = None
    labels: Optional[Dict[str, StrictStr]] = Field(default=None, description="A hash of label keys and values")
    service_tier: Optional[StrictInt] = Field(default=None, description="Integer representing service tier. Lower values represent higher criticality. If not specified the default value will be 5.")
    functionalities: Optional[List[PostV1ServicesFunctionalitiesInner]] = Field(default=None, description="An array of functionalities")
    links: Optional[List[PostV1ServicesLinksInner]] = Field(default=None, description="An array of links to associate with this service")
    owner: Optional[PostV1ServicesOwner] = None
    teams: Optional[List[PostV1ServicesTeamsInner]] = Field(default=None, description="An array of teams to attach to this service.")
    alert_on_add: Optional[StrictBool] = None
    auto_add_responding_team: Optional[StrictBool] = None
    external_resources: Optional[List[PostV1ServicesExternalResourcesInner]] = Field(default=None, description="An array of external resources to attach to this service.")
    __properties: ClassVar[List[str]] = ["name", "description", "labels", "service_tier", "functionalities", "links", "owner", "teams", "alert_on_add", "auto_add_responding_team", "external_resources"]

    @field_validator('service_tier')
    def service_tier_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set([0, 1, 2, 3, 4, 5]):
            raise ValueError("must be one of enum values (0, 1, 2, 3, 4, 5)")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PostV1Services from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in functionalities (list)
        _items = []
        if self.functionalities:
            for _item_functionalities in self.functionalities:
                if _item_functionalities:
                    _items.append(_item_functionalities.to_dict())
            _dict['functionalities'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in links (list)
        _items = []
        if self.links:
            for _item_links in self.links:
                if _item_links:
                    _items.append(_item_links.to_dict())
            _dict['links'] = _items
        # override the default output from pydantic by calling `to_dict()` of owner
        if self.owner:
            _dict['owner'] = self.owner.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in teams (list)
        _items = []
        if self.teams:
            for _item_teams in self.teams:
                if _item_teams:
                    _items.append(_item_teams.to_dict())
            _dict['teams'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in external_resources (list)
        _items = []
        if self.external_resources:
            for _item_external_resources in self.external_resources:
                if _item_external_resources:
                    _items.append(_item_external_resources.to_dict())
            _dict['external_resources'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PostV1Services from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "description": obj.get("description"),
            "labels": obj.get("labels"),
            "service_tier": obj.get("service_tier"),
            "functionalities": [PostV1ServicesFunctionalitiesInner.from_dict(_item) for _item in obj["functionalities"]] if obj.get("functionalities") is not None else None,
            "links": [PostV1ServicesLinksInner.from_dict(_item) for _item in obj["links"]] if obj.get("links") is not None else None,
            "owner": PostV1ServicesOwner.from_dict(obj["owner"]) if obj.get("owner") is not None else None,
            "teams": [PostV1ServicesTeamsInner.from_dict(_item) for _item in obj["teams"]] if obj.get("teams") is not None else None,
            "alert_on_add": obj.get("alert_on_add"),
            "auto_add_responding_team": obj.get("auto_add_responding_team"),
            "external_resources": [PostV1ServicesExternalResourcesInner.from_dict(_item) for _item in obj["external_resources"]] if obj.get("external_resources") is not None else None
        })
        return _obj


